/*************************************/
/* Fichier: alloc.c                  */
/* Version: 2.0                      */
/* Date:   July 2011                 */
/* Author: Didier Pinchon            */
/*************************************/
#include "rotation.h"

VecL *vecl_calloc(int lmax) 
{
   int l;
   VecL *vecl;
   vecl = (VecL *)calloc(1,sizeof(VecL));
   vecl->lmax = lmax;
   vecl->lvec = (gsl_vector **)calloc(lmax+1,sizeof(gsl_vector *));
   for (l=0;l<=lmax;l++) {
      vecl->lvec[l] = gsl_vector_calloc(2*l+1); 
}
   return vecl;   
}

void  vecl_free(VecL *vecl) 
{
   int l;
   for (l=0;l<=vecl->lmax;l++)
     gsl_vector_free(vecl->lvec[l]);
   free(vecl->lvec);
   free(vecl); 
}

MatL *matl_calloc(int lmax) 
{
   int l;
   MatL *matl;
   matl = (MatL *)calloc(1,sizeof(MatL));
   matl->lmax = lmax;
   matl->lmat = (gsl_matrix **)calloc(lmax+1,sizeof(gsl_matrix *));
   for (l=0;l<=lmax;l++) {
      matl->lmat[l] = gsl_matrix_calloc(2*l+1,2*l+1); 
}
   return matl;   
}

void  matl_free(MatL *matl) 
{
   int l;
   for (l=0;l<=matl->lmax;l++)
     gsl_matrix_free(matl->lmat[l]);
   free(matl->lmat);
   free(matl); 
}


