# spherical.mpl
with(orthopoly):

intSpherik := proc(f)
    local g;
    g := int(f,phi=0..2*Pi);
    simplify(int(g*sin(theta),theta=0..Pi));
end:

associatedLegendre := proc(l,m)
    if l=0 then RETURN(1); fi;
    if m<0 then ERROR("m should be non negative!"); fi;
    (-1)^m*1/(2^l*l!)*(sin(theta))^m*
       subs(x=cos(theta), diff( (x^2-1)^l ,seq(x,i=1..(l+m))) );
end:

YY := proc(l,m)
   local mm,x,res;
   if l=0 and m=0 then RETURN(1/(4*Pi)); fi;
   mm:=abs(m);
   res :=I^(m+mm)*
         simplify(sqrt((2*l+1)*(l-mm)!/(l+mm)!/4/Pi)*1/2^l/l!)*
         sin(theta)^mm*subs(x=cos(theta), diff( (x^2-1)^l,x$(l+mm)))*
         exp(I*m*phi);
end:

SS := proc(l,m)
    local cte;
    if m=0 then 
      RETURN(sqrt((2*l+1)/(4*Pi))*P(l,cos(theta))); 
    fi;
    cte := sqrt((2*l+1)*(l-abs(m))!/(l+abs(m))!/2/Pi);
    if m>0 then 
      RETURN( cte*associatedLegendre(l,m,theta)*cos(m*phi) );
    fi;   
    cte*associatedLegendre(l,-m,theta)*sin(-m*phi);
end:

