#include "rotation.h"

double myrand()  
{
  double x;
  x = (double) rand() / (double) RAND_MAX;
  return (2*M_PI*x); 
}

int main(int argc,char *argv[])
{
   int lmax;
   unsigned long nb,i,k;
   clock_t t1,t2;
   double alpha,beta,gamma,time;
   char *comm[300];
   MatL *matj, *matr;
   
   lmax = atoi(argv[1]);
   nb = atoi(argv[2]);
   
   printf("lmax = %d, nb = %u\n", lmax, nb);
   
   t1 = clock();
   
   matj = read_matJ(lmax, "numMatJ.dat");
   matr = matl_calloc(lmax);
   
   for (k=0;k<1000;k++) {
     for (i=0;i<nb;i++) {
       alpha = myrand();
       beta  = myrand();
       gamma = myrand();
       matl_rotation(lmax, alpha, beta, gamma, matr, matj);
     }
   }
   t2 = clock();
   time = (double)(t2-t1)/ CLOCKS_PER_SEC;
   
   printf("Time : %10.3e sec.\n", time);
   
   return EXIT_SUCCESS;
}
